/*
 * FromXMLParsers.h
 *
 * Created on: Apr 1, 2013
 * Author: Jan Travnicek
 */

#ifndef FROM_XML_PARSERS_H_
#define FROM_XML_PARSERS_H_

#include "label/LabelFromXMLParser.h"
#include "alphabet/SymbolFromXMLParser.h"
#include "regexp/RegExpFromXMLParser.h"
#include "string/StringFromXMLParser.h"
#include "automaton/AutomatonFromXMLParser.h"
#include "exception/ExceptionFromXMLParser.h"

namespace alib {

/**
 * Basic exception from which are derived all other exceptions.
 * Contains reason why the exception occured.
 */
class FromXMLParsers {
public:
	static const label::LabelFromXMLParser labelParser;
	static const alphabet::SymbolFromXMLParser symbolParser;
	static const regexp::RegExpFromXMLParser regexpParser;
	static const string::StringFromXMLParser stringParser;
	static const automaton::AutomatonFromXMLParser automatonParser;
	static const exception::ExceptionFromXMLParser exceptionParser;

};

} /* namespace alib */

#endif /* FROM_XML_PARSERS_H_ */
