/*
 * ToXMLComposers.h
 *
 * Created on: Apr 1, 2013
 * Author: Jan Travnicek
 */

#ifndef TO_XML_COMPOSERS_H_
#define TO_XML_COMPOSERS_H_

#include "label/LabelToXMLComposer.h"
#include "alphabet/SymbolToXMLComposer.h"
#include "regexp/RegExpToXMLComposer.h"
#include "string/StringToXMLComposer.h"
#include "automaton/AutomatonToXMLComposer.h"
#include "exception/ExceptionToXMLComposer.h"

namespace alib {

/**
 * Basic exception from which are derived all other exceptions.
 * Contains reason why the exception occured.
 */
class ToXMLComposers {
public:
	static const label::LabelToXMLComposer labelComposer;
	static const alphabet::SymbolToXMLComposer symbolComposer;
	static const regexp::RegExpToXMLComposer regexpComposer;
	static const string::StringToXMLComposer stringComposer;
	static const automaton::AutomatonToXMLComposer automatonComposer;
	static const exception::ExceptionToXMLComposer exceptionComposer;

};

} /* namespace alib */

#endif /* TO_XML_COMPOSERS_H_ */
