#include "SymbolFromStringLexer.h"
#include "../label/LabelFromStringLexer.h"

namespace alphabet {

SymbolFromStringLexer::SymbolFromStringLexer(std::stringstream& in) : m_In(in) {
	m_Current.type = TokenType::ERROR;
	m_Current.value = "";
}

SymbolFromStringLexer& SymbolFromStringLexer::next() {
	char character;
	m_Current.value = "";

	std::streampos pos = m_In.tellg();
L0:
	character = m_In.get();
	if(m_In.eof()) {
		m_In.seekg(pos);
		m_Current.type = TokenType::TEOF;
		return *this;
	} else if(character == ' ' || character == '\n' || character == '\t') {
		goto L0;
	} else if(character == '#') {
		goto L1;
	} else {
		m_In.seekg(pos);
		m_Current.type = TokenType::ERROR;
		return *this;
	}
L1:
	character = m_In.get();
	if(m_In.eof()) {
		m_In.seekg(pos);
		m_Current.type = TokenType::ERROR;
		return *this;
	} else if(character == 'B') {
		m_Current.type = TokenType::BLANK;
		return *this;
	} else if(character == 'Z') {
		m_Current.type = TokenType::BOTTOM;
		return *this;
	} else if(character == 'E') {
		m_Current.type = TokenType::END;
		return *this;
	} else {
		m_In.seekg(pos);
		m_Current.type = TokenType::ERROR;
		return *this;
	}
}

SymbolFromStringLexer::Token SymbolFromStringLexer::token() {
	return m_Current;
}

} /* namespace alphabet */
