/*
 * AlibException.cpp
 *
 * Created on: Apr 1, 2013
 * Author: Martin Zak
 */

#include "AlibException.h"

#include <cstdlib>
#include <iostream>
#include <stdexcept>
#include <sstream>

#include <execinfo.h>
#include "../std/stacktrace.h"

namespace exception {

AlibException::AlibException ( ) {
	this->backtrace = std::stacktrace();

	this->whatMessage += this->backtrace;
}

AlibException::AlibException ( const std::string & cause ) : AlibException() {
	this->cause = cause;
	
	this->whatMessage += this->cause;
}

AlibException::~AlibException ( ) noexcept {

}

const char * AlibException::what ( ) const noexcept {
	return whatMessage.c_str ( );
}

const std::string & AlibException::getCause ( ) const {
	return cause;
}

const std::string & AlibException::getBacktrace ( ) const {
	return backtrace;
}

} /* namespace exception */
