/*
 * RegExpFromStringParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef REG_EXP_FROM_STRING_PARSER_H_
#define REG_EXP_FROM_STRING_PARSER_H_

#include "RegExp.h"
#include "RegExpElements.h"

#include "RegExpFromStringLexer.h"
#include "../alphabet/SymbolFromStringParser.h"
#include "RegExpFeatures.h"

namespace regexp {

class RegExpFromStringParser {
	RegExpElement* alternation();
	RegExpElement* alternationCont(RegExpElement* left);
	RegExpElement* alternationContCont(Alternation* left);
	
	RegExpElement* concatenation();
	RegExpElement* concatenationCont(RegExpElement* left);
	RegExpElement* concatenationContCont(Concatenation* left);
	
	RegExpElement* factor();
	RegExpElement* star(RegExpElement* elem);

	RegExpFromStringLexer m_RegexpLexer;
	alphabet::SymbolFromStringParser m_SymbolParser;

	RegExp parse();
	RegExp parse(const std::set<FEATURES>& features);
	bool next();
public:
	bool first();
	RegExp* parsePointer();
	RegExpFromStringParser(std::stringstream&);
	RegExp parseValue();

};

} /* namespace regexp */

#endif /* REG_EXP_FROM_STRING_PARSER_H_ */
