#ifndef __LIST_HPP_
#define __LIST_HPP_

#include <list>

template< class T >
std::ostream& operator<<(std::ostream& out, const std::list<T>& list);

#include "set.hpp"
#include "map.hpp"
#include "pair.hpp"
#include "tuple.hpp"
#include "vector.hpp"
#include <iostream>

namespace std {

template< class T >
std::ostream& operator<<(std::ostream& out, const std::list<T>& list) {
	out << "[";

	bool first = true;
	for(const T& item : list) {
		if(!first) out << ", ";
		first = false;
		out << item;
	}

	out << "]";
	return out;
}

} /* namespace std */

#endif /* __LIST_HPP_ */

