#ifndef __MAP_HPP_
#define __MAP_HPP_

#include <map>

template< class T, class R >
std::ostream& operator<<(std::ostream& out, const std::map<T, R>& map);

#include "set.hpp"
#include "pair.hpp"
#include "list.hpp"
#include "tuple.hpp"
#include "vector.hpp"
#include <iostream>

namespace std {

template< class T, class R >
std::ostream& operator<<(std::ostream& out, const std::map<T, R>& map) {
	out << "{";

	bool first = true;
	for(const std::pair<T, R>& item : map) {
		if(!first) out << ", ";
		first = false;
		out << item;
	}

	out << "}";
	return out;
}

} /* namespace std */

#endif /* __MAP_HPP_ */

