#ifndef __TUPLE_HPP_
#define __TUPLE_HPP_

#include <tuple>

template< class... Ts>
std::ostream& operator<<(std::ostream& out, const std::tuple<Ts...>& tuple);

#include "set.hpp"
#include "map.hpp"
#include "list.hpp"
#include "pair.hpp"
#include "vector.hpp"
#include <iostream>

namespace std {

template<int I, class Tuple>
struct operator_shift_left_impl;

template<int I, class Tuple>
struct operator_shift_left_impl {
	static void operator_shift_left(ostream& out, const Tuple& t) {
		operator_shift_left_impl<I - 1, Tuple>::operator_shift_left(out, t);
		out << ", " << get<I>(t);
	}
};

template<class Tuple>
struct operator_shift_left_impl<0, Tuple> {
	static void operator_shift_left(ostream& out, const Tuple& t) {
		out << get<0>(t);
	}
};

template<class Tuple>
void operator_shift_left(ostream& out, const Tuple& t) {
	operator_shift_left_impl<tuple_size<Tuple>::value - 1, Tuple>::operator_shift_left(out, t);
}

template< class... Ts>
std::ostream& operator<<(std::ostream& out, const std::tuple<Ts...>& tuple) {
	out << "(";
	operator_shift_left(out, tuple);
	out << ")";
	return out;
}

} /* namespace std */

#endif /* __TUPLE_HPP_ */

