#ifndef __VECTOR_HPP_
#define __VECTOR_HPP_

#include <vector>

template< class T >
std::ostream& operator<<(std::ostream& out, const std::vector<T>& vector);

#include "set.hpp"
#include "map.hpp"
#include "pair.hpp"
#include "tuple.hpp"
#include "list.hpp"
#include <iostream>

namespace std {

template< class T >
std::ostream& operator<<(std::ostream& out, const std::vector<T>& vector) {
	out << "[";

	bool first = true;
	for(const T& item : vector) {
		if(!first) out << ", ";
		first = false;
		out << item;
	}

	out << "]";
	return out;
}

} /* namespace std */

#endif /* __VECTOR_HPP_ */

