/*
 * StringFromStringParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef STRING_FROM_STRING_PARSER_H_
#define STRING_FROM_STRING_PARSER_H_

#include "String.h"
#include "StringFeatures.h"
#include <vector>
#include "../alphabet/Symbol.h"

#include "StringFromStringLexer.h"
#include "../alphabet/SymbolFromStringParser.h"

namespace string {

class StringFromStringParser {
	std::vector<alphabet::Symbol> parseContent();
	
	StringFromStringLexer m_StringLexer;
	alphabet::SymbolFromStringParser m_SymbolParser;

	String parse();
	String parse(const std::set<FEATURES>& features);
	bool next();
public:
	bool first();
	String* parsePointer();
	StringFromStringParser(std::stringstream&);
	String parseValue();

};

} /* namespace string */

#endif /* STRING_FROM_STRING_PARSER_H_ */
