/*
 * StringFromXMLParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef STRING_FROM_XML_PARSER_H_
#define STRING_FROM_XML_PARSER_H_

#include "../FromXMLParser.hpp"
#include <vector>
#include <set>
#include "String.h"
#include "StringFeatures.h"
#include "../sax/Token.h"
#include "../alphabet/Symbol.h"

namespace string {

/**
 * Parser used to get String from XML parsed into list of tokens.
 */
class StringFromXMLParser : public alib::FromXMLParser<String, FEATURES> {
	void parseContent(std::list<sax::Token>& input, String& string, const std::set<FEATURES>& features) const;
	std::vector<alphabet::Symbol> parseContentData(std::list<sax::Token>& input) const;
	void parseAlphabet(std::list<sax::Token> &input, String& string) const;

	virtual String parse(std::list<sax::Token>& input) const;
	virtual String parse(std::list<sax::Token>& input, const std::set<FEATURES>& features) const;
public:
	virtual bool first(std::list<sax::Token>& input) const;
};

} /* namespace string */

#endif /* STRING_FROM_XML_PARSER_H_ */
